//
// P_WEBCLP.C
//
// Source code for a web-clipping plug-in module for
// TealAgent.
//
// (c)2000 TealPoint Software.  All Rights Reserved
//

#include "stdio.h"
#include "string.h"

#include <windows.h>

	#define FORMAT_TEALDOC	0
	#define MAX_TAG	500
	#define PRESEEK	32

	#define STRIP_CR(linebuf)	while( (linebuf)[0] && ((linebuf)[strlen((linebuf))-1]==10 || (linebuf)[strlen(linebuf)-1]==13) ) (linebuf)[strlen(linebuf)-1] = 0;

	int ConvertHTML( FILE *in_fp, FILE *out_fp, char *exit_string, int exit_count, char *hrule_string, char *head_start_string, char *head_end_string, char *head_break_string, int wordwrap_length, char *wordwrap_string );
	int SkipText( FILE *in_fp, char *exit_text, int count, int keepchars );

/*======================================================================
:::
::: GetParams()
:::
======================================================================*/

	static int  p_format=FORMAT_TEALDOC;
	static int	p_url_count = 0;
	static char p_urls[50][200]= {"http://www.tealpoint.com"};
	static char p_filename[200]="Clipped Page";
	static char p_starttext[40]="";
	static char p_endtext[40]="";
	static int  p_startcount=0;
	static int  p_endcount=0;
	
	static int p_adddate  = 0;
	static int p_addtime  = 0;
	static int p_addurl   = 1; 
	static int p_addtitle = 1;
	static int p_addstart = 0; 
	static int p_addend   = 0;
	static int p_html     = 1;

void GetParams(void)		
{
	FILE *fp;
	char linebuf[201];
	char oldbuf[201];
	char tstr[201];
	int  tint,i;

	if (fp=fopen("params.in","rt")) {

		while(fgets(linebuf,200,fp)) {

			STRIP_CR(linebuf);
			if (!strncmp(linebuf,"TEXTAREA",8)) {
				sscanf( linebuf, "%s %d", tstr, &tint );
				p_url_count = tint-1;
				for (i=0; i<p_url_count; i++) {
					fgets(p_urls[i],200,fp);
					STRIP_CR(p_urls[i]);
				}
			}
			if (!strcmp(linebuf,"File Name on Palm")) {
				strcpy(p_filename,oldbuf);
			}
			if (!strcmp(linebuf,"TealDoc")) {
				sscanf(oldbuf,"%s %d %d",tstr,&tint,&p_format);
			}
			if (!strcmp(linebuf,"occurance of")) {
				strcpy(p_starttext,oldbuf);
			}
			if (!strcmp(linebuf,"   occurance of")) {
				strcpy(p_endtext,oldbuf);
			}
			if (!strcmp(linebuf,"First")) {
				sscanf(oldbuf,"%s %d %d",tstr,&tint,&p_startcount);
			}
			if (!strcmp(linebuf,"Next")) {
				sscanf(oldbuf,"%s %d %d",tstr,&tint,&p_endcount);
			}
			if (!strcmp(linebuf,"Add Date to Name")) {
				sscanf(oldbuf,"%s %d %d %d %d %d %d %d %d",
					tstr,&tint,&p_adddate, &p_addtime, &p_addurl, &p_addtitle,
					&p_addstart, &p_addend, &p_html );
			}

			strcpy( oldbuf, linebuf );
		}

		fclose(fp);
	}
}

/*======================================================================
:::
::: OutData()
:::
======================================================================*/

void OutData( char *fname, char *text )
{
	FILE *fp;
	if (fp=fopen( fname, "wt")) {
		fprintf(fp,"%s",text);
		fclose(fp);
	}
}

/*======================================================================
:::
::: AddData()
:::
======================================================================*/

void AddData( char *fname, char *text )
{
	FILE *fp;
	if (fp=fopen( fname, "rt+")) {
		fseek(fp,0,SEEK_END);
		fprintf(fp,"%s",text);
		fclose(fp);
	}
}

/*======================================================================
:::
::: Main()
:::
======================================================================*/

#define TD_HRULE_TEXT "<HRULE>"
#define TD_HRULE_STRT "<HEADER STYLE=UNDERLINED ALIGN=CENTER FONT=1 TEXT=\""
#define TD_HRULE_STOP "\">"
#define TD_HRULE_WRAP "\">\015\012<HEADER STYLE=UNDERLINED ALIGN=CENTER FONT=1 TEXT=\""
#define TD_HRULE_NUM  20

#define UD_HRULE_TEXT "     \x97\x97\x97\x97\x97\x97\x97\x97\x97\x97" "\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\015\012"
#define UD_HRULE_STRT ""
#define UD_HRULE_STOP "\015\012"
#define UD_HRULE_WRAP ""
#define UD_HRULE_NUM  10000

main( int argc, char **argv )
{
	if (argc>1) {

		//
		// -n: Return Module Name
		//

		if (!strcmp(argv[1],"-n")) {
			OutData("data.out", "* Universal Page Clipper");
			OutData("status.out","DONE");
		}

		//
		// -a: Return About Info
		//

		else if (!strcmp(argv[1],"-a")) {
			OutData("data.out", 
					"Universal Page Clipper Module\n"
					"Version 0.95 October 3, 2000\n"
					"(c)2000 TealPoint Software\n\n"

					"This module formats a specified web page or\n"
					"section of a web page or text file, converting\n" 
					"it into a doc file for viewing on the Palm.\n" );
			OutData("status.out","DONE");
		}

		//
		// -p: Return Configuration Parameters and default settings
		//

		else if (!strcmp(argv[1],"-p")) {
			OutData("data.out", 
			"[ Unnamed Clipping Task ]\n"		

			"UPDATE 3\n"
			"p_webclp.exe\n" 
			"http://www.robofish.com/download/plugins/p_webclp.zip\n"
			"Update PageClip Plug-in\n" 

			"TEXT 2 200 32\n"  	 	
			"Clipped Document\n"
			"File Name on Palm\n"		

			"TEXTAREA 2 300 50 10000\n"			
			"http://[ insert URLs or file paths here on separate lines ]\n"
			"Download URLs or Paths\n" 		

			"DROPDOWN 6 0\n"		
			"First\n"				
			"Second\n"				
			"Third\n"				
			"Fourth\n"		
			"Fifth\n"					
			"Clip each page from the...\n"   	

			"TEXT 2 250 32\n\n"   	
			"occurance of\n"	

			"DROPDOWN 6 0\n"		
			"Next\n"					
			"Second Next\n"		
			"Third Next\n"			
			"Fourth Next\n"		
			"Fifth Next\n"		
			"   until the...\n"   		

			"TEXT 2 250 32\n\n"   	
			"   occurance of\n"	

			"CHECKBOX 8 0 0 1 1 0 0 1\n"	
			"Add Date to Name\n" 	 	
			"Add Time to Name\n" 	 	
			"Include URL in Page\n" 	 	
			"Include Title in Page\n"  	
			"Include start tag\n"
			"Include end tag\n"	
			"Convert from HTML\n"	
			"Options\n" 

			"RADIO 3 0\n"   	
			"TealDoc\n"	
			"Generic Doc\n"	
			"Output Format\n"	

			);

			OutData("status.out","DONE");
		}

		//
		// -s: Start conversion
		// For this module, we request a web page and flag a return
		//

		else if (!strcmp(argv[1],"-s")) {
			int i;
			char tstr[20];

			GetParams();

			OutData("status.out","");

			for (i=0; i<p_url_count; i++) if (p_urls[i][0]) {

				sprintf( tstr, " clip%04d.tmp -o\n", i );

				AddData("status.out","HTTP ");
				AddData("status.out", p_urls[i] );
				AddData("status.out", tstr );
			}
			AddData("status.out", "MESSAGE Analyzing Page(s)...\nRETURN\n" );
		}

		//
		// -e: Fetch Error
		//

		else if (!strcmp(argv[1],"-e")) {

			OutData("status.out", "ERROR: Could not fetch requested page");
		}

		//
		// -r<n>: Returned from previous call
		// For this module, we analyze the page(s) we just requested
		//

		else if (!strcmp(argv[1],"-r0")) {
			FILE *in_fp, *out_fp;
			char tstr[20];
			int i,savepos;

			GetParams();

			//
			// Open Files
			//

			if (out_fp=fopen("clipout.tmp","wb")) {

				for (i=0; i<p_url_count; i++) {

					sprintf( tstr, "clip%04d.tmp", i );
			
					if (in_fp=fopen( tstr,"rb")) {

						//==================================
						//
						// Add URL
						//
						//==================================

						if (p_addurl) {
							fprintf( out_fp, "%s%c%c", p_urls[i],13,10 );
						}

						if (p_html) {

							//
							// Add Title
							//

							fprintf(stderr,"Scanning title\n");

							if (p_addtitle) {
								if (!SkipText( in_fp, "<TITLE", 1,0 )) {
									SkipText( in_fp, ">", 1,0 );

									if (p_format==FORMAT_TEALDOC) {
										fprintf( out_fp, "<HEADER ALIGN=CENTER STYLE=UNDERLINED FONT=1 TEXT=\"" );
									} else {
										fprintf( out_fp, "\015\012" );
									}

									ConvertHTML( in_fp, out_fp, "</TITLE", 1, "","","","",20,
										"\">\015\012<HEADER STYLE=UNDERLINED ALIGN=CENTER FONT=1 TEXT=\""
									); 
									SkipText( in_fp, ">", 1,0 );

									if (p_format==FORMAT_TEALDOC) {
										fprintf( out_fp, "\">\015\012" );
									} else {
										fprintf( out_fp, "\015\012" );
									}
								} else {
									fseek( in_fp, 0, SEEK_SET );
								}
							}

							fprintf(stderr,"Scanning body\n");

							//
							// Process Body
							//

							savepos = ftell( in_fp );

							if (p_starttext[0]) if (SkipText( in_fp, p_starttext, p_startcount+1,0 )) {
								fseek( in_fp, savepos, SEEK_SET );
							}

							if (p_format==FORMAT_TEALDOC) {
								ConvertHTML( in_fp, out_fp, p_endtext, p_endcount+1,
									TD_HRULE_TEXT, TD_HRULE_STRT, TD_HRULE_STOP, TD_HRULE_WRAP, TD_HRULE_NUM,0 );
							} else {
								ConvertHTML( in_fp, out_fp, p_endtext, p_endcount+1,
									UD_HRULE_TEXT, UD_HRULE_STRT, UD_HRULE_STOP, UD_HRULE_WRAP, UD_HRULE_NUM,0 );
							}

							if (p_format!=FORMAT_TEALDOC) {
								fprintf( out_fp, "<>" );
							}
						}

						//==================================
						//
						// Straight copy
						//
						//==================================

						else {
							int c;
							while ((c=fgetc(in_fp)) != EOF) {
								fputc( c,out_fp );
							}
						}


						fclose(in_fp);
					}
				}

				fclose(out_fp);
			}

			//
			// Write Out Status
			//

			if (p_adddate) {
				char date[50];

				GetDateFormat( LOCALE_USER_DEFAULT, DATE_SHORTDATE, NULL, NULL, date, 50 );

				strcat( p_filename, " " );
				strcat( p_filename, date );
			}

			if (p_addtime) {
				char time[50];

				GetTimeFormat( LOCALE_USER_DEFAULT, 0, NULL, NULL, time, 50 );

				strcat( p_filename, " " );
				strcat( p_filename, time );
			}

			p_filename[31] = 0;

			OutData("status.out","MAKEDOC clipout.tmp \x22");
			AddData("status.out",p_filename);
			if (p_format=FORMAT_TEALDOC) {
				AddData("status.out","\x22 -t\nDONE\n");
			} else {
				AddData("status.out","\x22\nDONE\n");
			}

		}

		else goto showusage;
	}

	else {
showusage:
		printf(	"Universal Page Clipper Module\n" 
					"(c)2000 TealPoint Software\n\n"

					"This module formats a specified web page or\n"
					"section of a web page, converting it into a doc\n" 
					"file for viewing on the Palm.\n" );
	}
}


typedef struct {
	char loname[10];
	char lochar;
	char hiname[10];
	char hichar;
} SPECIALS;

SPECIALS special_table[] = {

	{ "plusmn;"	, 177, "\0", 0 },
	{ "iexcl;"	, 161, "\0", 0 },
	{ "szlig;"	, 223, "\0", 0 },
	{ "sup1;"	, 185, "\0", 0 },
	{ "sup2;"	, 178, "\0", 0 },
	{ "sup3;"	, 179, "\0", 0 },
	{ "cent;"	, 162, "\0", 0 },
	{ "pound;"	, 163, "\0", 0 },
	{ "curren;"	, 164, "\0", 0 },
	{ "micro;"	, 181, "\0", 0 },
	{ "yen;"		, 165, "\0", 0 },
	{ "para;"	, 182, "\0", 0 },
	{ "brvbar;"	, 166, "\0", 0 },
	{ "middot;"	, 183, "\0", 0 },
	{ "sect;"	, 167, "\0", 0 },
	{ "cedil;"	, 184, "\0", 0 },
	{ "uml;"		, 168, "\0", 0 },
	{ "copy;" 	, 169, "\0", 0 },
	{ "ordm;" 	, 186, "\0", 0 },
	{ "ordf;" 	, 170, "\0", 0 },
	{ "raquo;" 	, 187, "\0", 0 },
	{ "laquo;" 	, 171, "\0", 0 },
	{ "frac14;" , 188, "\0", 0 },
	{ "not;" 	, 172, "\0", 0 },
	{ "frac12;"	, 189, "\0", 0 },
	{ "shy;"		, 173, "\0", 0 },
	{ "frac34;"	, 190, "\0", 0 },
	{ "reg;"		, 174, "\0", 0 },
	{ "iquest;"	, 191, "\0", 0 },
	{ "macr;"	, 175, "\0", 0 },
	{ "times;"	, 215, "\0", 0 },
	{ "deg;"		, 176, "\0", 0 },
	{ "div;"		, 247, "\0", 0 },

	{ "amp;"		, '&', "\0", 0 },
	{ "gt;"		, '>', "\0", 0 },
	{ "lt;"		, '<', "\0", 0 },
	{ "quot;" 	, '"', "\0", 0 },

	{ "agrave;"	, 224, "Agrave;"	, 192 },
	{ "aacute;"	, 225, "Aacute;"	, 193 },
	{ "acirc;"	, 226, "Acirc;"	, 194 },
	{ "auml;"	, 228, "Auml;"		, 196 },
	{ "ccedil;"	, 231, "Ccedil;"	, 199 },
	{ "egrave;"	, 232, "Egrave;"	, 200 },
	{ "eacute;"	, 233, "Eacute;"	, 201 },
	{ "ecirc;"	, 234, "Ecirc;" 	, 202 },
	{ "igrave;"	, 236, "Igrave;"	, 204 },
	{ "iacute;" , 237, "Iacute;"	, 205 },
	{ "icirc;"	, 238, "Icirc;"	, 206 },
	{ "ntilde;"	, 241, "Ntilde;"	, 209 },
	{ "ograve;"	, 242, "Ograve;"	, 210 },
	{ "oacute;"	, 243, "Oacute;"	, 211 },
	{ "ocirc;"	, 244, "Ocirc;"	, 212 },
	{ "ouml;"	, 246, "Ouml;"		, 214 },
	{ "ugrave;"	, 249, "Ugrave;"	, 217 },
	{ "uacute;"	, 250, "Uacute;"	, 218 },
	{ "ucirc;"	, 251, "Ucirc;"	, 219 },
	{ "uuml;"	, 252, "Uuml;"		, 220 },

	{ "\0",0,"\0",0 }

};

		
/*======================================================================
:::
::: ConvertHTML()
:::
======================================================================*/

	#define PUTCHAR(c)		fputc(c,out_fp)
	#define PUTSTRING(str)	fprintf(out_fp,"%s",str)
	#define UNSEEK(c)			fseek(in_fp,-(c),SEEK_CUR);

	#define ADVANCE_SEEK(len) {	\
		for (i=0; i<PRESEEK-(len); i++) prechar[i] = preseek[i] = preseek[i+(len)]; \
		for (i=0; i<(len); i++) {																	 \
			prechar[PRESEEK-(len)+i] = preseek[PRESEEK-(len)+i] = fgetc(in_fp);	 \
		} }

	#define FLAG_UNSPACE(len)	{ unspacecount+=len; spacecount = 0; x+=len; crcount=0; }
	#define FLAG_SPACE(len)		{ spacecount+=len; unspacecount = 0; x+=len; crcount=0; }
	#define FLAG_CR()				{ spacecount++; unspacecount = 0; x=0; crcount++; }

	#define NEW_LINE() {	\
		if (x || crcount<2) {				\
			PUTCHAR(13);	\
			PUTCHAR(10);	\
			FLAG_CR();		\
		} }

	#define DBL_LINE() \
		{   \
			NEW_LINE();	 \
			NEW_LINE();  \
		}

	#define CHECK_COLUMN() \
		{if (!x) for (i=0; i<column_count+nest_count; i++) {PUTSTRING("   ");}}

int ConvertHTML( FILE *in_fp, FILE *out_fp, char *exit_string, int exit_count, char *hrule_string, char *head_start_string, char *head_end_string, char *head_break_string, int wordwrap_length, char *wordwrap_string )
{
	int  c,x=0,i,rx=0;
	int  caps_mode = 0;

	int  nest_count   = 0;
	int  column_count = 0;
	int  crcount   	= 0;
	int  spacecount   = 0;
	int  unspacecount = 0;

	int  preseek[PRESEEK+1];
	char prechar[PRESEEK+1];

	char *disabled_string = 0L;

	//
	// Fill Pre Buffer
	//

	ADVANCE_SEEK(PRESEEK);

	do {
nextchar:
		c = preseek[0];

		//======================================================
		//
		// Check for exit condition
		//
		//======================================================

		if (exit_string && exit_string[0]) {
			if (!strnicmp( prechar, exit_string, strlen(exit_string) )) {
				if (--exit_count<=0) {
					UNSEEK( PRESEEK-strlen(exit_string));
					return 0;
				}
			}
		}

		//======================================================
		//
		// Check for disability
		//
		//======================================================

		if (disabled_string) {
			if (!strnicmp( prechar, disabled_string, strlen(disabled_string) )) {
				ADVANCE_SEEK(strlen(disabled_string));
				disabled_string = 0;
				continue;
			}
		}

		//======================================================
		//	
		// Convert special characters
		//	
		//======================================================

		else {

			//--------------------------------------------------------
			//	
			// Convert any	'&' characters
			//	
			//--------------------------------------------------------

			if (c=='&') {

				if (prechar[1]=='#' && prechar[5]==';' &&
					 prechar[2]>='0' && prechar[2]<='9' &&	
				    prechar[3]>='0' && prechar[3]<='9' &&	
				    prechar[4]>='0' && prechar[4]<='9' ) {

					int val = (prechar[2]-'0') * 100 +
					          (prechar[3]-'0') * 10  +
					          (prechar[4]-'0');

					ADVANCE_SEEK(6);
					if (val) {
						CHECK_COLUMN();
						FLAG_UNSPACE(1);
						PUTCHAR( val );
					}
					continue;
				}

				else if (!strnicmp( prechar, "&nbsp;", 6)) {
					c = ' ';
					ADVANCE_SEEK(5);
				}

				else {
					SPECIALS *sp = special_table;

					while (sp->loname[0]) {

						if (!strncmp( prechar+1, sp->loname, strlen(sp->loname) )) {
							CHECK_COLUMN();
							PUTCHAR( (caps_mode && sp->hiname[0]) ? sp->hichar : sp->lochar );
							FLAG_UNSPACE(1);
							ADVANCE_SEEK(strlen(sp->loname)+1);
							goto nextchar;
						} 

						else if ( sp->hiname[0] ) {
							if (!strncmp( prechar+1, sp->hiname, strlen(sp->hiname) )) {
								CHECK_COLUMN();
								PUTCHAR( sp->hichar );
								FLAG_UNSPACE(1);
								ADVANCE_SEEK(strlen(sp->hiname)+1);
								goto nextchar;
							}
						}
						sp++;
					}
				}
			}

			//--------------------------------------------------------
			//	
			// Process Tags
			//	
			//--------------------------------------------------------

			if (c=='<') {

				//	
				// Special TealDoc Tag?  Keep in document
				//	
				//	This is a sneaky way to put content in a web page
				// that will appear in the converted doc file
				//	

				if (!strncmp( prechar, "<!--TD", 6)) {

		 			ADVANCE_SEEK(6);

				  	while ( preseek[0] != EOF && strncmp( prechar, "-->",3)) {
						PUTCHAR( preseek[0] );
						ADVANCE_SEEK(1);
				  	}
					ADVANCE_SEEK(3);
					continue;
				}

 				//	
 				//	Skip Comments
 				//	

 				else if (!strncmp( prechar, "<!--", 4)) {
					disabled_string = "-->";
					continue;
				}

	  			//	
	  			//	Skip Scripts
	  			//	

	  			else if (!strnicmp( prechar, "<SCRIPT", 7)) {
					disabled_string = "/SCRIPT>";
					continue;
				}

	  			//	
	  			//	Skip Styles
	  			//	

	  			else if (!strnicmp( prechar, "<STYLE", 6)) {
					disabled_string = "/STYLE>";
					continue;
				}

				//	
				//	Line Break
				//	

	  			else if (!strnicmp( prechar, "<BR", 3)) {
					NEW_LINE();
				}

				//	
				//	Paragraph Break
				//	

	  			else if (!strnicmp( prechar, "<P", 2)) {
					DBL_LINE();
				}

				//	
				//	Horiz Rules
				//	

	  			else if (!strnicmp( prechar, "<HR", 3)) {
					NEW_LINE();
					PUTSTRING( hrule_string );
					FLAG_CR();
				}

				//	
				//	List Item
				//	

	  			else if (!strnicmp( prechar, "<LI", 3)) {
					NEW_LINE();
					CHECK_COLUMN();
					PUTSTRING( " " );
					FLAG_UNSPACE(2);
				}

				//	
				//	List Term
				//	

	  			else if (!strnicmp( prechar, "<DT", 3)) {
					DBL_LINE();
					CHECK_COLUMN();
					PUTCHAR(155);
					PUTCHAR(' ');
					FLAG_UNSPACE(2);
				}

				//	
				//	List Definition
				//	

	  			else if (!strnicmp( prechar, "<DD", 3)) {
					DBL_LINE();
					CHECK_COLUMN();
					PUTCHAR(187);
					PUTCHAR(' ');
					FLAG_UNSPACE(2);
				}

				//	
				//	List Start
				//	

	  			else if (!strnicmp( prechar, "<OL", 3) ||
	  			         !strnicmp( prechar, "<UL", 3)	||
	  				      !strnicmp( prechar, "<DL", 3)	 ) {

					nest_count++;
					DBL_LINE();
				}

				//	
				//	List End
				//	

	  			else if (!strnicmp( prechar, "</OL", 4) ||
	  			         !strnicmp( prechar, "</UL", 4) ||
	  				      !strnicmp( prechar, "</DL", 4)	) {

					nest_count--;
					DBL_LINE();
				}

				//
				// Table
				//

	  			else if (!strnicmp( prechar, "<TR", 3)) {
					column_count = 0;
					NEW_LINE();
				}

	  			else if (!strnicmp( prechar, "<SUP", 4)) {
					PUTCHAR('(');
					FLAG_UNSPACE(1);
				}

	  			else if (!strnicmp( prechar, "</SUP", 5)) {
					PUTCHAR(')');
					FLAG_UNSPACE(1);
				}

	  			else if (!strnicmp( prechar, "<TD", 3)) {
					column_count++;
					NEW_LINE();
				}

	  			else if (!strnicmp( prechar, "<TABLE", 6)) {
					DBL_LINE();
				}

	  			else if (!strnicmp( prechar, "</TABLE", 7)) {
					DBL_LINE();
				}

				//	
				//	Block Quotes
				//	

	  			else if (!strnicmp( prechar, "<BLOCKQUOTE", 11)) {
					nest_count++;
				}
	  			else if (!strnicmp( prechar, "</BLOCKQUOTE", 12)) {
					nest_count--;
				}

				//
				// Headers
				//

	  			else if (!strnicmp( prechar, "<H1", 3) ||
	  			         !strnicmp( prechar, "<H2", 3) ||
	  			         !strnicmp( prechar, "<H3", 3) ||
	  			         !strnicmp( prechar, "<H4", 3) ||
	  				      !strnicmp( prechar, "<H5", 3)	) {

					DBL_LINE();
					FLAG_SPACE(1);
					PUTSTRING( head_start_string );
					wordwrap_string = head_break_string;
				}

				//
				// Headers
				//

	  			else if (!strnicmp( prechar, "</H1", 4) ||
	  			         !strnicmp( prechar, "</H2", 4) ||
	  			         !strnicmp( prechar, "</H3", 4) ||
	  			         !strnicmp( prechar, "</H4", 4) ||
	  				      !strnicmp( prechar, "</H5", 4)	) {

					PUTSTRING( head_end_string );
					NEW_LINE();
					wordwrap_string = 0;
				}

				//	
				//	Bold
				//	

	  			else if (!strnicmp( prechar, "<B>", 3)) {
					caps_mode++;
				}
	  			else if (!strnicmp( prechar, "</B>", 4)) {
					caps_mode--;
				}

				disabled_string = ">";
				continue;
			}

			//--------------------------------------------------------
			//	
			// Whitespace
			//	
			//--------------------------------------------------------

			else if (c==' ' || c==9 || c==10 || c==13) {

				// if a wordwrap flagged, insert the wordwrap string if
				// character count exceeded

				if (wordwrap_string && x>wordwrap_length) {
					PUTSTRING( wordwrap_string );
					FLAG_CR();
					FLAG_SPACE(1);
				}

				// otherwise output a space if the first whitespace char

				else if (!spacecount) {
					PUTCHAR( ' ' );
					FLAG_SPACE(1);
				}
			}

			//--------------------------------------------------------
			//
			// Normal, put out character
			//
			//--------------------------------------------------------

			else {
				CHECK_COLUMN();
				FLAG_UNSPACE(1);

				if (caps_mode) {
					if (c>='a' && c<='z') c += 'A'-'a';
				}

				PUTCHAR(c);
			}
		}

		ADVANCE_SEEK(1);

	} while (prechar[0]!=EOF);

	return -1;
}

/*======================================================================
:::
::: SkipText()
:::
======================================================================*/
		
int SkipText( FILE *in_fp, char *exit_string, int exit_count, int keeptext )
{
	int  i,c;
	int  preseek[PRESEEK];
	char prechar[PRESEEK];

	//
	// Fill Pre Buffer
	//

	ADVANCE_SEEK(PRESEEK);

	do {
		c = prechar[0];

		//======================================================
		//
		// Check for exit condition
		//
		//======================================================

		if (exit_string && exit_string[0]) {
			if (!strnicmp( prechar, exit_string, strlen(exit_string) )) {
				if (--exit_count<=0) {
					UNSEEK( PRESEEK-(keeptext ? 0:strlen(exit_string)));
					return 0;
				}
			}
		}

		ADVANCE_SEEK(1);
		
	} while (prechar[0]!=EOF);

	return -1;
}

		
